unit Option;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, BELib;

type
  TfrmOption = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    chkReadOnly: TCheckBox;
    Font1: TFontDialog;
    Color1: TColorDialog;
    Button4: TButton;
    Button5: TButton;
    TabSheet2: TTabSheet;
    GroupBox1: TGroupBox;
    pnlFont: TPanel;
    GroupBox2: TGroupBox;
    ListBox1: TListBox;
    btnFontColor: TButton;
    btnBkColor: TButton;
    pnlFontColor: TPanel;
    Button3: TButton;
    chkDoubleBuffered: TCheckBox;
    Label1: TLabel;
    chkBackup: TCheckBox;
    edtBackupCount: TEdit;
    Label2: TLabel;
    UpDown1: TUpDown;
    chkFileSaveWithoutClearUndo: TCheckBox;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    edtTopMargin: TEdit;
    udTopMargin: TUpDown;
    Label3: TLabel;
    Label4: TLabel;
    edtBottomMargin: TEdit;
    udBottomMargin: TUpDown;
    Label5: TLabel;
    edtLeftMargin: TEdit;
    udLeftMargin: TUpDown;
    chkPrintFileName: TCheckBox;
    chkPrintPageNo: TCheckBox;
    GroupBox4: TGroupBox;
    pnlPrintFont: TPanel;
    Button1: TButton;
    chkUseShellExtention: TCheckBox;
    procedure Button3Click(Sender: TObject);
    procedure btnFontColorClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure btnBkColorClick(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure chkBackupClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure SetFontColorPanel;
    procedure ApplySettings;

  public
    FNormalColor: TColor;
    FNormalBkColor: TColor;
    FSelectColor: TColor;
    FSelectBkColor: TColor;
    FCurrentLineColor: TColor;
    FCurrentLineBkColor: TColor;
    FAddressColor: TColor;
    FAddressBkColor: TColor;
    FUnderLineColor: TColor;
  end;

var
  frmOption: TfrmOption;

implementation

uses Main;

{$R *.DFM}

procedure TfrmOption.Button3Click(Sender: TObject);
begin
  Font1.Font := pnlFont.Font;
  if Font1.Execute then
    pnlFont.Font := Font1.Font;
end;

procedure TfrmOption.btnFontColorClick(Sender: TObject);
begin
  Color1.Color := pnlFontColor.Font.Color;
  if Color1.Execute then
  begin
    case ListBox1.ItemIndex of
      0: FNormalColor      := Color1.Color; // ʏ
      1: FSelectColor      := Color1.Color; // I
      2: FCurrentLineColor := Color1.Color; // J[\s
      3: FUnderLineColor   := Color1.Color; // J[\sA_[C
      4: FAddressColor     := Color1.Color; // AhXwb_
    end;
    SetFontColorPanel;
  end;
end;

procedure TfrmOption.FormCreate(Sender: TObject);
begin
  MoveMainFormCenter(Self, frmMain);
  PageControl1.ActivePageIndex := 0;

  pnlFont.Font.Assign(frmMain.MxBinEditor1.Font);
  pnlFont.Font.Color := clBlack;

  with frmMain.MxBinEditor1 do
  begin
    FNormalColor        := Font.Color;
    FNormalBkColor      := Color;
    FSelectColor        := SelectColor;
    FSelectBkColor      := SelectBGColor;
    FCurrentLineColor   := CurrentLineColor;
    FCurrentLineBkColor := CurrentLineBGColor;
    FAddressColor       := AddressColor;
    FAddressBkColor     := AddressBGColor;
    chkBackup.Checked   := SaveBackup;
    UpDown1.Position    := SaveBackupCount;
    chkDoubleBuffered.Checked  := DoubleBuffered;
    FUnderLineColor     := UnderLineColor;
  end;

  chkUseShellExtention.Checked := UsingShellExtention;

  chkBackupClick(Self);
  SetFontColorPanel;

end;

procedure TfrmOption.ListBox1Click(Sender: TObject);
begin
  SetFontColorPanel;
end;

procedure TfrmOption.SetFontColorPanel;
begin
  case ListBox1.ItemIndex of
    0: begin // ʏ
         pnlFontColor.Font.Color := FNormalColor;
         pnlFontColor.Color      := FNormalBkColor;
       end;
    1: begin // I
         pnlFontColor.Font.Color := FSelectColor;
         pnlFontColor.Color      := FSelectBkColor;
       end;
    2: begin // J[\s
         pnlFontColor.Font.Color := FCurrentLineColor;
         pnlFontColor.Color      := FCurrentLineBkColor;
       end;
    3: begin // J[\sA_[C
         pnlFontColor.Font.Color := FUnderLineColor;
         pnlFontColor.Color      := FNormalBkColor;
       end;
    4: begin // AhXwb_
         pnlFontColor.Font.Color := FAddressColor;
         pnlFontColor.Color      := FAddressBkColor;
       end;
  end;
  btnFontColor.Enabled := ListBox1.ItemIndex <> -1;
  btnBkColor.Enabled := ListBox1.ItemIndex <> -1;
end;

procedure TfrmOption.btnBkColorClick(Sender: TObject);
begin
  if ListBox1.ItemIndex = 3 then
  begin
    MsgBox('̍ڂ̔wiF͐ݒł܂B', MB_ICONINFORMATION);
    Exit;
  end;

  Color1.Color := pnlFontColor.Color;
  if Color1.Execute then
  begin
    case ListBox1.ItemIndex of
      0: FNormalBkColor      := Color1.Color; // ʏ
      1: FSelectBkColor      := Color1.Color; // I
      2: FCurrentLineBkColor := Color1.Color; // J[\s
      4: FAddressBkColor     := Color1.Color; // AhXwb_
    end;
    SetFontColorPanel;
  end;
end;

procedure TfrmOption.ApplySettings;
begin
  with frmMain.MxBinEditor1 do
  begin
    Font               := pnlFont.Font;
    Font.Color         := FNormalColor;
    Color              := FNormalBkColor;
    SelectColor        := FSelectColor;
    SelectBGColor      := FSelectBkColor;
    CurrentLineColor   := FCurrentLineColor;
    CurrentLineBGColor := FCurrentLineBkColor;
    AddressColor       := FAddressColor;
    AddressBGColor     := FAddressBkColor;
    UnderLineColor     := FUnderLineColor;
    DoubleBuffered     := chkDoubleBuffered.Checked;
    SaveBackup         := chkBackup.Checked;
    SaveBackupCount    := UpDown1.Position;
  end;

  if chkUseShellExtention.Checked then
    SetComObject
  else
    DelComObject;

end;

procedure TfrmOption.Button4Click(Sender: TObject);
begin
  ApplySettings;
end;

procedure TfrmOption.chkBackupClick(Sender: TObject);
begin
  edtBackupCount.Enabled := chkBackup.Checked;
  UpDown1.Enabled := chkBackup.Checked;
end;

procedure TfrmOption.Button1Click(Sender: TObject);
begin
  Font1.Font := pnlPrintFont.Font;
  if Font1.Execute then
    pnlPrintFont.Font := Font1.Font;
end;

end.
