unit Version;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, BELib;

type
  TfrmVersion = class(TForm)
    Image1: TImage;
    Label1: TLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormDestroy(Sender: TObject);
  private
    procedure WMEraseBkgnd(var Msg:TWMEraseBkgnd); message WM_ERASEBKGND;
  public
  end;

var
  frmVersion: TfrmVersion;

implementation

uses Main;

{$R *.DFM}

procedure TfrmVersion.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  Close;
end;

procedure TfrmVersion.FormCreate(Sender: TObject);
begin
  OnKeyDown := nil;
  OnClick   := nil;
  Image1.OnClick := nil;
  Label1.OnClick := nil;
  OnDeactivate   := nil;

  ClientWidth  := Image1.Width;
  ClientHeight := Image1.Height;
  MoveMainFormCenter(Self, frmMain);
end;

procedure TfrmVersion.FormClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmVersion.FormActivate(Sender: TObject);
var
  i: Integer;
  Rgn: HRGN;
begin
  OnActivate := nil;

  for i := 50 downto 0 do
  begin
    Rgn := CreateRectRgn(i * 3, i, Width - i * 3, Height - i);
    SetWindowRgn(Handle, Rgn, True);
    Application.ProcessMessages;
    Sleep(2);
  end;

  OnKeyDown      := FormKeyDown;
  OnClick        := FormClick;
  Image1.OnClick := FormClick;
  Label1.OnClick := FormClick;
  OnDeactivate   := FormDeactivate;
  
end;

procedure TfrmVersion.WMEraseBkgnd(var Msg:TWMEraseBkgnd);
begin
//
end;

procedure TfrmVersion.FormDeactivate(Sender: TObject);
begin
  Close;
end;

procedure TfrmVersion.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  while Assigned(OnActivate) do
    Application.ProcessMessages;
  Action := caFree;
end;

procedure TfrmVersion.FormDestroy(Sender: TObject);
begin
  frmVersion := nil;
end;

end.
